class EinfacherZaehler():

    def __init__(self):
        self.__stand=0  # int

    def Zaehle(self):
        '''zaehlt den Zaehler um 1 weiter'''
        self.__stand += 1

    def ZeigeStand(self):
        '''gibt den aktuellen Zaehlerstand zurueck'''
        return self.__stand


class Zaehler(EinfacherZaehler):

    def __init__(self):
        EinfacherZaehler.__init__(self)
        
    
    def Zuruecksetzen(self):
        '''setzt den Zaehler auf 0 zurueck'''
        self._EinfacherZaehler__stand=0

class ZyklischerZaehler(Zaehler):
    
    def __init__(self, zykluslaenge):
        self.__zykluslaenge=zykluslaenge

    def Zaehle(self):
        super().Zaehle()
        if self.ZeigeStand()==self.__zykluslaenge:
            self.Zuruecksetzen()

### -----------------------------------------    
import unittest

class Test_EinfacherZaehler(unittest.TestCase):

    def setUp(self):
        self.instanz = EinfacherZaehler()

    def test_Initialisierung(self):
        self.assertTrue(self.instanz.ZeigeStand()==0)

    def test_Aktionen(self):
        '''alle Namen von Tests muessen mit "test_" beginnen'''
        self.instanz.Zaehle()
        self.assertTrue(self.instanz.ZeigeStand()==1)
        self.instanz.Zaehle()
        self.assertTrue(self.instanz.ZeigeStand()==2)
        
class Test_Zaehler(unittest.TestCase):

    def setUp(self):
        self.instanz = Zaehler()

    def test_Initialisierung(self):
        self.assertTrue(self.instanz.ZeigeStand()==0)

    def test_Aktionen(self):
        '''alle Namen von Tests muessen mit "test_" beginnen'''
        self.instanz.Zaehle()
        self.assertTrue(self.instanz.ZeigeStand()==1)
        self.instanz.Zaehle()
        self.assertTrue(self.instanz.ZeigeStand()==2)
        self.instanz.Zuruecksetzen()
        self.assertTrue(self.instanz.ZeigeStand()==0)
        self.instanz.Zaehle()
        self.assertTrue(self.instanz.ZeigeStand()==1)

### -----------------------------------------    
if __name__ == '__main__':
    unittest.main()
